install 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. OSInfo() {
  11. #printf "Detectando SO..."
  12. OS=$(uname -s)
  13. if [ $OS = "Linux" ]; then
  14. OS="GNU/Linux"
  15. if [ -f /etc/os-release ]; then
  16. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  17. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  18. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  19. for i in $ID_LIKE; do
  20. #printf "$i\n"
  21. case $i in
  22. debian|ubuntu)
  23. debianOS=true
  24. break
  25. ;;
  26. rhel|fedora)
  27. rhelOS=true
  28. break
  29. ;;
  30. *)
  31. debianOS=false
  32. rhelOS=false
  33. ;;
  34. esac
  35. done
  36. elif [ -f /etc/debian-version ]; then
  37. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  38. DIST="Debian"
  39. REV=""
  40. ID_LIKE="debian"
  41. debianOS=true
  42. elif [ -f /etc/redhat-release ]; then
  43. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  44. DIST="Red-Hat"
  45. REV=""
  46. ID_LIKE="rhel"
  47. rhelOS=true
  48. else
  49. # Other Linux (No Soportado)
  50. DIST=""
  51. REV=""
  52. ID_LIKE=""
  53. fi
  54. else
  55. # UNIX, OS X, ... (No Soportado)
  56. DIST=$OS
  57. REV=""
  58. fi
  59. #printf " $OS $DIST $REV\n"
  60. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  61. }
  62. comprobarRoot() {
  63. if [ $(id -u) -ne 0 ]; then
  64. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  65. exit 1
  66. fi
  67. }
  68. comprobarDependencias() {
  69. # Comprobamos whiptail
  70. which whiptail > /dev/null 2>&1
  71. if [ $? -ne 0 ];then
  72. printf "ERROR:\t'whiptail' no disponible.\n"
  73. exit 1
  74. fi
  75. # Comprobamos hostnamectl
  76. which hostnamectl > /dev/null 2>&1
  77. if [ $? -ne 0 ];then
  78. printf "ERROR:\t'hostnamectl' no disponible.\n"
  79. exit 1
  80. fi
  81. if [ $debianOS = true ];then
  82. # Comprobamos apt-get
  83. which apt-get > /dev/null 2>&1
  84. if [ $? -ne 0 ]; then
  85. printf "ERROR:\t'apt-get' no está disponible.\n"
  86. exit 1
  87. fi
  88. # Actualizamos base de datos del repositorio
  89. printf "Actualizando repositorio APT..."
  90. result=$(apt-get -q -y update)
  91. if [ $? -ne 0 ]; then
  92. printf "\nERROR:\tImposible actualizar repositorio.\n"
  93. printf "Detalles:\n$result\n"
  94. exit 1
  95. fi
  96. printf " OK.\n"
  97. # Comprobamos Firewall (ufw)
  98. which ufw > /dev/null 2>&1
  99. if [ $? -ne 0 ]; then
  100. printf "ERROR:\t'ufw' no disponible.\n"
  101. exit 1
  102. fi
  103. fi
  104. if [ $rhelOS = true ]; then
  105. # Comprobamos yum
  106. which yum > /dev/null 2>&1
  107. if [ $? -ne 0 ]; then
  108. printf "ERROR:\t'yum' no está disponible.\n"
  109. exit 1
  110. fi
  111. # Actualizamos base de datos del repositorio
  112. printf "Actualizando repositorio YUM..."
  113. result=$(yum -y makecache 2>&1)
  114. if [ $? -ne 0 ]; then
  115. printf "\nERROR:\tImposible actualizar repositorio.\n"
  116. printf "Detalles:\n$result\n"
  117. exit 1
  118. fi
  119. printf " OK.\n"
  120. # Comprobamos Firewall (firewall-cmd)
  121. which firewall-cmd > /dev/null 2>&1
  122. if [ $? -ne 0 ]; then
  123. printf "ERROR:\t'firewall-cmd' no disponible.\n"
  124. exit 1
  125. fi
  126. fi
  127. }
  128. inicializarVariables() {
  129. debianOS=false
  130. rhelOS=false
  131. apacheOn=false
  132. nginxOn=false
  133. mySQLOn=false
  134. mariaDBOn=false
  135. phpOn=false
  136. mediaWikiOn=false
  137. moodleOn=false
  138. actualizacionesOn=false
  139. }
  140. instalacionExpress() {
  141. apacheOn=true
  142. mariaDBOn=true
  143. phpOn=true
  144. mediaWikiOn=true
  145. moodleOn=true
  146. actualizacionesOn=true
  147. }
  148. comprobarHostname() {
  149. while [ -z $hostname ]; do
  150. hostname=$(whiptail --title "HOSTNAME" --inputbox "El nombre de dominio de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" --ok-button "Cambiar" --cancel-button "No Cambiar" 20 70 3>&1 1>&2 2>&3)
  151. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  152. hostnamectl set-hostname $hostname
  153. else
  154. hostname=$(hostname)
  155. fi
  156. done
  157. #printf "\nHostname: $hostname\n"
  158. }
  159. mostrarBienvenida() {
  160. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  161. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --ok-button "Salir" 20 70
  162. exit 1
  163. fi
  164. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --yes-button "Continuar" --no-button "Salir" 20 70
  165. if [ $? -ne 0 ]; then
  166. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  167. exit 2
  168. fi
  169. }
  170. mostrarExpress() {
  171. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" 20 70 2 \
  172. "Express" "Instalación rápida" ON \
  173. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  174. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  175. if [ $? -ne 0 ]; then
  176. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  177. exit 2
  178. fi
  179. case $express in
  180. Express)
  181. instalacionExpress
  182. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  183. ;;
  184. Avanzada)
  185. mostrarAvanzada
  186. ;;
  187. *)
  188. printf "ERROR:\tError interno (selección express).\n"
  189. exit 1
  190. ;;
  191. esac
  192. }
  193. mostrarAvanzada() {
  194. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 7 \
  195. "WebServer" "Instalar servidor web http/https" ON \
  196. "Database" "Instalar una base de datos SQL" ON \
  197. "PHP" "Instala PHP7" ON \
  198. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  199. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  200. "Moodle" "Instalar campus virtual con Moodle" ON \
  201. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  202. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  203. if [ $? -ne 0 ]; then
  204. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  205. exit 2
  206. fi
  207. # Mejora: autodetección de componentes ya instalados
  208. for i in $componentes; do
  209. case $i in
  210. \"WebServer\")
  211. mostrarWebServer
  212. ;;
  213. \"Database\")
  214. mostrarDatabase
  215. ;;
  216. \"PHP\")
  217. phpOn=true
  218. ;;
  219. \"SSL/TLS\")
  220. # 2 Opciones: Let's Encrypt o Autofirmado
  221. ;;
  222. \"MediaWiki\")
  223. mediaWikiOn=true
  224. ;;
  225. \"Moodle\")
  226. moodleOn=true
  227. ;;
  228. \"Actualizaciones\")
  229. actualizacionesOn=true
  230. ;;
  231. *)
  232. printf "ERROR:\tError interno (selección de componentes).\n"
  233. exit 1
  234. ;;
  235. esac
  236. done
  237. }
  238. mostrarWebServer() {
  239. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
  240. "Apache" "Instalar el servidor web Apache2" ON \
  241. "Nginx" "Instalar el servidor web Nginx" OFF \
  242. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  243. if [ $? -ne 0 ]; then
  244. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  245. exit 2
  246. fi
  247. # Preguntar otras opciones de configuración
  248. comprobarHostname
  249. case $webServer in
  250. Apache)
  251. apacheOn=true
  252. ;;
  253. Nginx)
  254. nginxOn=true
  255. ;;
  256. *)
  257. printf "ERROR:\tError interno (selección de web server).\n"
  258. exit 1
  259. ;;
  260. esac
  261. }
  262. instalarApache() {
  263. if [ $debianOS = true ];then
  264. result=$(apt-get -q -y install apache2 2>&1)
  265. if [ $? -ne 0 ]; then
  266. printf "\nERROR:\tError al instalar Apache2.\n"
  267. printf "Detalles:\n$result\n"
  268. exit 1
  269. fi
  270. elif [ $rhelOS = true ]; then
  271. result=$(yum -y install httpd 2>&1)
  272. if [ $? -ne 0 ]; then
  273. printf "\nERROR:\tError al instalar Apache2.\n"
  274. printf "Detalles:\n$result\n"
  275. exit 1
  276. fi
  277. else
  278. printf "\nERROR:\tError interno (instalación Apache2).\n"
  279. exit 1
  280. fi
  281. }
  282. instalarNginx() {
  283. if [ $debianOS = true ];then
  284. result=$(apt-get -q -y install nginx 2>&1)
  285. if [ $? -ne 0 ]; then
  286. printf "\nERROR:\tError al instalar Nginx.\n"
  287. printf "Detalles:\n$result\n"
  288. exit 1
  289. fi
  290. elif [ $rhelOS = true ]; then
  291. # Hay que instalar primero otro repositorio
  292. result=$(yum -y install epel-release)
  293. if [ $? -ne 0 ]; then
  294. printf "\nERROR:\tError al intalar repositorio 'epel-release'.\n"
  295. printf "Detalles:\n$result\n"
  296. exit 1
  297. fi
  298. result=$(yum -y install nginx 2>&1)
  299. if [ $? -ne 0 ]; then
  300. printf "\nERROR:\tError al instalar Nginx.\n"
  301. printf "Detalles:\n$result\n"
  302. exit 1
  303. fi
  304. else
  305. printf "\nERROR:\tError interno (instalación Nginx).\n"
  306. exit 1
  307. fi
  308. }
  309. mostrarDatabase() {
  310. if [ $debianOS = true ]; then
  311. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
  312. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  313. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  314. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  315. if [ $? -ne 0 ]; then
  316. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  317. exit 2
  318. fi
  319. # Preguntar otras opciones de configuración
  320. case $database in
  321. MySQL)
  322. mySQLOn=true
  323. ;;
  324. MariaDB)
  325. mariaDBOn=true
  326. ;;
  327. *)
  328. printf "ERROR:\tError interno (selección de base de datos).\n"
  329. exit 1
  330. ;;
  331. esac
  332. elif [ $rhelOS = true ]; then
  333. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." --yes-button "Continuar" --no-button "Salir" 20 70
  334. if [ $? -ne 0 ]; then
  335. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  336. exit 2
  337. fi
  338. mariaDBOn=true
  339. else
  340. printf "ERROR:\tError interno (instalación Base de Datos).\n"
  341. exit 1
  342. fi
  343. }
  344. instalarMySQL() {
  345. if [ $debianOS = true ];then
  346. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  347. if [ $? -ne 0 ]; then
  348. printf "\nERROR:\tError al instalar MySQL.\n"
  349. printf "Detalles:\n$result\n"
  350. exit 1
  351. fi
  352. elif [ $rhelOS = true ]; then
  353. # MySQL no disponible en RHEL. 2 opciones:
  354. # 1) Instalar un repositorio adicional
  355. # 2) No instalar MySQL en distribuciones RHEL
  356. printf "\nERROR:\tRHEL no incluye MySQL en sus repositorios.\n"
  357. exit 1
  358. else
  359. printf "\nERROR:\tError interno (instalación MySQL).\n"
  360. exit 1
  361. fi
  362. }
  363. instalarMariaDB() {
  364. if [ $debianOS = true ];then
  365. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  366. if [ $? -ne 0 ]; then
  367. printf "\nERROR:\tError al instalar MariaDB.\n"
  368. printf "Detalles:\n$result\n"
  369. exit 1
  370. fi
  371. elif [ $rhelOS = true ]; then
  372. result=$(yum -y install mariadb-server 2>&1)
  373. if [ $? -ne 0 ]; then
  374. printf "\nERROR:\tError al instalar MariaDB.\n"
  375. printf "Detalles:\n$result\n"
  376. exit 1
  377. fi
  378. else
  379. printf "\nERROR:\tError interno (instalación MariaDB).\n"
  380. exit 1
  381. fi
  382. }
  383. # Comprobación del sistema e inicialización
  384. comprobarRoot
  385. inicializarVariables
  386. OSInfo
  387. comprobarDependencias
  388. # Bienvenida
  389. mostrarBienvenida
  390. # Selección de componentes (express vs avanzada)
  391. mostrarExpress
  392. # Pre-configuración
  393. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  394. # Instalación
  395. # FALTA: whiptail --gauge -> Más bonito
  396. # Servidor Web
  397. if [ $apacheOn = true ]; then
  398. printf "Instalando Web Server Apache..."
  399. instalarApache
  400. printf " OK.\n"
  401. elif [ $nginxOn = true ]; then
  402. printf "Instalando Web Server Nginx..."
  403. instalarNginx
  404. printf " OK.\n"
  405. fi
  406. # Base de Datos
  407. if [ $mySQLOn = true ]; then
  408. printf "Instalando Base de Datos MySQL..."
  409. instalarMySQL
  410. printf " OK.\n"
  411. elif [ $mariaDBOn = true ]; then
  412. printf "Instalando Base de Datos MariaDB..."
  413. instalarMariaDB
  414. printf " OK.\n"
  415. fi
  416. # PHP
  417. if [ $phpOn = true ]; then
  418. printf "Instalando PHP-7..."
  419. printf " OK.\n"
  420. fi
  421. # SSL/TLS
  422. # Falta por implementar
  423. # MediaWiki
  424. if [ $mediaWikiOn = true ]; then
  425. printf "Instalando MediaWiki..."
  426. printf " OK.\n"
  427. fi
  428. # Moodle
  429. if [ $moodleOn = true ]; then
  430. printf "Instalando Moodle..."
  431. printf " OK.\n"
  432. fi
  433. # Configuración
  434. # Configuración Apache
  435. # Virtual Hosts
  436. # Configuración Database
  437. # Configuración Segura
  438. # Configuración PHP
  439. # cgi.fix_pathinfo=0
  440. # Configurar máximo de subida de archivos
  441. # Configuración MediWiki
  442. # Configuración Moodle
  443. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  444. # Añadir reglas del cortafuegos
  445. # Configuración SSL/TLS
  446. # Generar certificados
  447. # Configurar certificados
  448. # Configurar actualizaciones
  449. if [ $actualizacionesOn = true ]; then
  450. printf "Configurando actualizaciones automáticas..."
  451. # CRONTAB
  452. printf " OK.\n"
  453. fi
  454. # Autodestrucción
  455. {
  456. for i in $(seq 0 5 50); do
  457. sleep 0.1
  458. echo $i
  459. done
  460. } | whiptail --gauge "Autodestrucción..." 7 70 0
  461. {
  462. for i in $(seq 50 5 100); do
  463. sleep 0.1
  464. echo $i
  465. done
  466. } | whiptail --gauge "Autopulverización..." 7 70 50